# _*_ coding: iso-8859-1 _*_
# Change les ACLs d'un fichier/dossier (non rcursivement, TODO utiliser "AddAccessAllowedAceEx" pour a)
import win32security as wsec
import win32file as wf
import win32api as wa
import ntsecuritycon as ntsec
import logging
import traceback

def AdjustPrivilege(privileges):
    """Active les privilges lists dans privileges
    """
    if type(privileges) == str: privileges = [privileges]
    for priv in privileges:
        # Get the process token.
        flags = ntsec.TOKEN_ADJUST_PRIVILEGES | ntsec.TOKEN_QUERY
        htoken = wsec.OpenProcessToken(wa.GetCurrentProcess(), flags)
        # Get the ID for the privilege.
        pr_id = wsec.LookupPrivilegeValue(None, priv)
        # Now obtain the privilege for this process.
        newPrivileges = [(pr_id, ntsec.SE_PRIVILEGE_ENABLED)]
        # and make the adjustment.
        wsec.AdjustTokenPrivileges(htoken, 0, newPrivileges)
        htoken.Close()

def AjouterPrivilege(username, privilege, scribe):
    """Ajoute le privilgre <privilege>  <username>
    <scribe> est le nom SMB de Scribe
    """
    policy_handle = wsec.LsaOpenPolicy(None, wsec.POLICY_ALL_ACCESS)
    sid_obj, domain, tmp = wsec.LookupAccountName(scribe, username)
    wsec.LsaAddAccountRights(policy_handle, sid_obj, (privilege,))
    wsec.LsaClose(policy_handle)
    
def set_acl(obj, domain=None, scribe=''):
    """Met l'ACL "contrle total" sur obj
    non rcursivement pour "DomainUsers"
    """
    # Le SID de DomainUsers
    if domain: dusers = r'%s\DomainUsers'%domain
    else: dusers = 'DomainUsers'
    logging.debug("Mise en place d'ACLs pour %s sur %s"%(dusers, obj))
    try:
        try:
            domainusers_sid = wsec.LookupAccountName(scribe, dusers)
        except:
            logging.debug('Erreur LookupAccountName')
            return
        domainusers_sid = domainusers_sid[0]
        # rcupration du descripteur (vive le franais) de scu
        info = wsec.DACL_SECURITY_INFORMATION
        sd = wsec.GetFileSecurity(obj, info)
        # les ACLs
        acl = sd.GetSecurityDescriptorDacl()
        # ajout de l'ACL Accs complet pour DomainUSers
        acl.AddAccessAllowedAceEx(wsec.ACL_REVISION_DS, wsec.OBJECT_INHERIT_ACE, wf.FILE_ALL_ACCESS, domainusers_sid)
        # maj du Security Descriptor
        sd.SetSecurityDescriptorDacl(1, acl, 0)
        # application sur l'objet
        wsec.SetFileSecurity(obj, info, sd)
        logging.debug("Mise en place d'ACLs reussi")
    except Exception, e:
        logging.error("Erreur d'application des ACLs %s"%([obj, dusers, e]))
        logging.debug('Erreur %s'%traceback.format_exc())




